From a42c638efe75cdd54f69f62292866e52a478752c Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 11 2020 22:12:32 +0000
Subject: [PATCH 1701/2232] Merge pull request #566 from dtolnay/vec-copy


Add Vec copy constructor and copy assignment operator
---

diff --git a/include/cxx.h b/include/cxx.h
index 86de118..e3ef0be 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -241,10 +241,12 @@ public:
 
   Vec() noexcept;
   Vec(std::initializer_list<T>);
+  Vec(const Vec &);
   Vec(Vec &&) noexcept;
   ~Vec() noexcept;
 
   Vec &operator=(Vec &&) noexcept;
+  Vec &operator=(const Vec &);
 
   size_t size() const noexcept;
   bool empty() const noexcept;
@@ -649,6 +651,12 @@ Vec<T>::Vec(std::initializer_list<T> init) : Vec{} {
 }
 
 template <typename T>
+Vec<T>::Vec(const Vec &other) : Vec() {
+  this->reserve_total(other.size());
+  std::copy(other.begin(), other.end(), std::back_inserter(*this));
+}
+
+template <typename T>
 Vec<T>::Vec(Vec &&other) noexcept : repr(other.repr) {
   new (&other) Vec();
 }
@@ -669,6 +677,15 @@ Vec<T> &Vec<T>::operator=(Vec &&other) noexcept {
 }
 
 template <typename T>
+Vec<T> &Vec<T>::operator=(const Vec &other) {
+  if (this != &other) {
+    this->drop();
+    new (this) Vec(other);
+  }
+  return *this;
+}
+
+template <typename T>
 bool Vec<T>::empty() const noexcept {
   return size() == 0;
 }

